.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include DlgMain.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL QueryStr:DWORD

.if uMsg == WM_INITDIALOG

		invoke	GetDlgItem,hWnd,IDC_LIST
		mov	hList,eax
	
		
		invoke	InsertColumns
		invoke	AddLine,addr szText,addr szText,addr szText
		invoke	AddLine,addr szText,addr szText,addr szText
   
		invoke	AddLine,addr szText,addr szText,addr szText
		invoke	AddLine,addr szText,addr szText,addr szText
		invoke	AddLine,addr szText,addr szText,addr szText
		invoke	AddLine,addr szText,addr szText,addr szText
		invoke	AddLine,addr szText,addr szText,addr szText
		mov	SetLineColorNum,-1
   

	.elseif uMsg == WM_NOTIFY
		push	edi
		mov	edi,lParam
		mov	eax, [edi.NMHDR].hwndFrom
		.if	eax == hList
			.if [edi.NMHDR].code == NM_RDBLCLK	;Set Color on focus
				invoke	SendMessage,hList,LVM_GETNEXTITEM,-1,LVNI_FOCUSED
				mov	CancelLineColorNum,eax
			.elseif [edi.NMHDR].code == NM_DBLCLK	;Remove Color on focus
				invoke	SendMessage,hList,LVM_GETNEXTITEM,-1,LVNI_FOCUSED
				mov	SetLineColorNum,eax
			.endif
		.endif
		
		mov	edi,lParam
		assume	edi:ptr NMLVCUSTOMDRAW
		mov	eax,[edi].nmcd.hdr.code
		.if	eax== NM_CUSTOMDRAW
			mov	eax,[edi].nmcd.dwDrawStage
			.if	eax==CDDS_PREPAINT
				mov eax,CDRF_NOTIFYITEMDRAW
				ret
			.elseif eax==CDDS_ITEMPREPAINT
				mov [edi].clrTextBk,096DAFDH;eax
				mov [edi].clrText,0FF0000h
				mov eax,CDRF_NOTIFYSUBITEMDRAW
				ret
			.elseif eax==CDDS_SUBITEM or CDDS_ITEMPREPAINT
				mov	ebx,SetLineColorNum
				mov	ecx,CancelLineColorNum
				.if	[edi].nmcd.dwItemSpec==ebx
					mov [edi].clrTextBk,044BCFCh
				.elseif [edi].nmcd.dwItemSpec==ecx
					mov [edi].clrTextBk,096DAFDH
				.endif
				mov	SetLineColorNum,-1
				mov	CancelLineColorNum,-1
			.endif
			mov eax,CDRF_NEWFONT
			ret
		.endif
		ASSUME edi:nothing           
		pop	edi
	.elseif uMsg == WM_CLOSE
		invoke	DestroyWindow, hWnd
	
	.endif
ret0:
         xor    eax, eax
         ret
DlgProc endp

InsertColumns proc
	LOCAL lvc:LV_COLUMN

	invoke SendMessage,hList,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT or LVS_EX_FLATSB ,-1
	mov lvc.imask,LVCF_TEXT+LVCF_WIDTH
	mov lvc.pszText,0
	mov lvc.lx,100
	invoke SendMessage,hList, LVM_INSERTCOLUMN,0,addr lvc
	or lvc.imask,LVCF_FMT
	mov lvc.fmt,LVCFMT_LEFT ;CENTER
	mov lvc.pszText,0
	mov lvc.lx,130
	invoke SendMessage,hList, LVM_INSERTCOLUMN, 1 ,addr lvc
	mov lvc.pszText,0
	mov lvc.lx,120
	invoke SendMessage,hList, LVM_INSERTCOLUMN, 2 ,addr lvc
	
	ret
InsertColumns endp

AddLine PROC Location:DWORD,Byte1:DWORD,Byte2:DWORD

	invoke	lstrcpy,addr hText,Location
	mov	lvi.imask,LVIF_TEXT
	mov	lvi.pszText,offset hText
	mov	lvi.iSubItem,0
	invoke	SendMessage,hList,LVM_INSERTITEM,0,addr lvi
	mov	lvi.iItem,eax
	inc	lvi.iSubItem
	invoke	lstrcpy,addr hText,Byte1
	invoke	SendMessage,hList,LVM_SETITEM,0,addr lvi
	inc	lvi.iSubItem
	invoke	lstrcpy,addr hText,Byte2
	invoke	SendMessage,hList,LVM_SETITEM,0,addr lvi
	ret 
	
AddLine ENDP


end start
